<?php

namespace Schaffen\SerasaRemessa\Http\Advanced\PJ\SubTypes\F900;

use Schaffen\SerasaRemessa\Utils\Record;
use Schaffen\SerasaRemessa\Utils\RecordColumn;
use Schaffen\SerasaRemessa\Utils\Util;

class SubTypeNREA_3 extends Record {
    public $name = "riskscoring_value_calc";
    
    public $templateColumns = [
        [
            'name' => "type_rule",
            'position' => 1,
            'size' => 4,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "cod_feat",
            'position' => 5,
            'size' => 4,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "subtipo",
            'position' => 9,
            'size' => 2,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "bairro",
            'position' => 11,
            'size' => 45,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "cidade",
            'position' => 56,
            'size' => 45,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "uf",
            'position' => 101,
            'size' => 2,
            'type' =>  RecordColumn::TYPE_NUMERIC,
        ],
        [
            'name' => "cep",
            'position' => 103,
            'size' => 8,
            'type' =>  RecordColumn::TYPE_NUMERIC,
        ],
        [
            'name' => "ident",
            'position' => 111,
            'size' => 1,
            'type' =>  RecordColumn::TYPE_NUMERIC,
        ],
        [
            'name' => "filler",
            'position' => 112,
            'size' => 4,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
    ];

    public function __construct($values = null) {
        $this->createColumns();
        
        if($values !== null) {
            $this->setValues($values);
        }
    }

    public function setValues($values) {
        $newValues = $this->getValues();
        
        $newValues['type_rule'] = substr($values, 0, 4);
        $newValues['cod_feat'] = substr($values, 4, 4);
        $newValues['subtipo'] = substr($values, 8, 2);
        $newValues['bairro'] = substr($values, 10, 45);
        $newValues['cidade'] = substr($values, 55, 45);
        $newValues['uf'] = substr($values, 100, 2);
        $newValues['cep'] = substr($values, 102, 8);
        $newValues['ident'] = substr($values, 110, 1);
        $newValues['filler'] = substr($values, 111, 4);
        
        $this->setColumnsValues($newValues);
    }
}