<?php

namespace Schaffen\SerasaRemessa\Http\Advanced\PJ\SubTypes\F900;

use Schaffen\SerasaRemessa\Utils\Record;
use Schaffen\SerasaRemessa\Utils\RecordColumn;
use Schaffen\SerasaRemessa\Utils\Util;

class SubTypeSSCN_SF_4 extends Record {
    public $name = "spc";

    public $templateColumns = [   
        [
            'name' => "type_rule",
            'position' => 1,
            'size' => 4,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "cod_cons",
            'position' => 5,
            'size' => 4,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "inf",
            'position' => 9,
            'size' => 2,
            'type' =>  RecordColumn::TYPE_NUMERIC,
        ],
        [
            'name' => "bloco",
            'position' => 11,
            'size' => 2,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "atividade_economica",
            'position' => 13,
            'size' => 100,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "expansao",
            'position' => 113,
            'size' => 3,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
    ];

    public function __construct($values = null) {
        $this->createColumns();
        
        if($values !== null) {
            $this->setValues($values);
        }
    }

    public function setValues($values) {
        $newValues = $this->getValues();
        
        $newValues['type_rule'] = substr($values, 0, 4);
        $newValues['cod_cons'] = substr($values, 4, 4);
        $newValues['bloco'] = substr($values, 8, 2);
        $newValues['tp_pessoa'] = substr($values, 10, 1);
        $newValues['docto'] = substr($values, 11, 9);
        $newValues['dig_docto'] = substr($values, 20, 2);
        $newValues['nome'] = substr($values, 22, 65);
        $newValues['nac'] = substr($values, 87, 12);
        $newValues['cargo'] = substr($values, 99, 12);
        $newValues['filial'] = substr($values, 111, 4);
        
        $this->setColumnsValues($newValues);
    }

}